package org.ow2.jasmine.monitoring.eos.confeditor.control
{
    import flash.events.Event;
    import flash.events.MouseEvent;
    
    import mx.collections.ArrayCollection;
    import mx.containers.Canvas;
    import mx.controls.Button;
    import mx.controls.ComboBox;
    import mx.controls.DataGrid;
    import mx.controls.Label;
    import mx.controls.TextInput;
    import mx.controls.dataGridClasses.DataGridColumn;
    import mx.core.ClassFactory;
    
    import org.ow2.jasmine.monitoring.eos.common.utils.logger.EoSLogger;

    public class GraphXML extends Canvas
    {

        //title of the graph
        private var graphTitleLabel:Label;
        private var graphTitleTextInput:TextInput;

        //type of the graph
        private var graphTypeLabel:Label;
        private var graphTypeComboBox:ComboBox;

        // for the add of a probe
        private var addProbeButton:Button;

        //datagrid
        private var myDataGrid:DataGrid;

        private var idDataGridColumn:DataGridColumn;
        private var valueDataGridColumn:DataGridColumn;
        private var nameDataGridColumn:DataGridColumn;
        private var descriptionDataGridColumn:DataGridColumn;
        private var patternDataGridColumn:DataGridColumn;
        private var serverDataGridColumn:DataGridColumn;
        //private var colorDataGridColumn:DataGridColumn;
        private var optionDataGridColumn:DataGridColumn;
        
        private var deleteButtonRenderer:ClassFactory;

        private var dataGridContent:ArrayCollection;

        private var graphTypesAvailable:ArrayCollection;

        //xml editor
        //private var xmlEditor:TextArea;

        public function GraphXML(title:String, typesAvailable:ArrayCollection, probes:ArrayCollection, type:String)
        {
            this.graphTitleLabel = new Label();
            this.graphTitleLabel.text = "Graph title : ";
            this.graphTitleLabel.y = 0;

            this.graphTitleTextInput = new TextInput();
            this.graphTitleTextInput.addEventListener(Event.CHANGE,titleHandler);
            this.graphTitleTextInput.text = title;
            this.graphTitleTextInput.x = 70;
            this.graphTitleTextInput.y = 0;

            this.graphTypeLabel = new Label();
            this.graphTypeLabel.text = "Graph type : ";
            this.graphTypeLabel.x = 300;
            this.graphTypeLabel.y = 0;

            this.graphTypeComboBox = new ComboBox();
            this.graphTypeComboBox.dataProvider = typesAvailable;
            this.graphTypeComboBox.addEventListener(flash.events.Event.CHANGE, changeGraphButtonMenuClickHandler);
            this.graphTypeComboBox.x = 375;
            this.graphTypeComboBox.y = 0;

            this.graphTypesAvailable = typesAvailable;
            for (var i:int = 0; i < typesAvailable.length; i++){
                if (typesAvailable.getItemAt(i).value == type) {
                    this.graphTypeComboBox.selectedIndex = i;
                }
            }

            this.addProbeButton = new Button();
            this.addProbeButton.label = "Add serie";
            this.addProbeButton.toolTip = "Add a new serie to this graph";
            this.addProbeButton.x = 505;
            this.addProbeButton.y = 0;
            this.addProbeButton.addEventListener(MouseEvent.CLICK, addProbeHandler);

            this.myDataGrid = new DataGrid();
            this.idDataGridColumn = new DataGridColumn("Id");
            this.valueDataGridColumn = new DataGridColumn("IndicatorName");
            this.nameDataGridColumn = new DataGridColumn("Name");
            this.descriptionDataGridColumn = new DataGridColumn("Description");
            this.patternDataGridColumn = new DataGridColumn("PatternFilter");
            this.serverDataGridColumn = new DataGridColumn("ServerSource");
            //this.colorDataGridColumn = new DataGridColumn("color");
            //colorDataGridColumn.itemRenderer = new ClassFactory(ColorPickerRenderer);
            this.optionDataGridColumn = new DataGridColumn("Option");
            this.deleteButtonRenderer = new ClassFactory (DeleteButtonRenderer);
            optionDataGridColumn.itemRenderer = deleteButtonRenderer;
            

            var columns:Array = [];
            columns.push(idDataGridColumn);
            columns.push(valueDataGridColumn);
            columns.push(nameDataGridColumn);
            columns.push(descriptionDataGridColumn);
            columns.push(patternDataGridColumn);
            columns.push(serverDataGridColumn);
            //columns.push(colorDataGridColumn);
            columns.push(optionDataGridColumn);
            myDataGrid.columns = columns;

            this.dataGridContent = new ArrayCollection();
            this.dataGridContent = probes;

            myDataGrid.dataProvider = dataGridContent;
            myDataGrid.x = 0;
            myDataGrid.y = 25;
            // TODO : remove these lines when probes will addable from the datagrid control
            myDataGrid.editable = true;
            this.optionDataGridColumn.editable = false;
            //this.colorDataGridColumn.editable = false;

            this.addChild(myDataGrid);
            this.addChild(graphTitleLabel);
            this.addChild(graphTitleTextInput);
            this.addChild(graphTypeLabel);
            this.addChild(graphTypeComboBox);
            this.addChild(addProbeButton);

            this.label = title;
        }

        public function getGraphTitle():String{
            return this.graphTitleTextInput.text;
        }

        public function getGraphType():String{
            return this.graphTypesAvailable.getItemAt(this.graphTypeComboBox.selectedIndex).value.toString();
        }

        public function getDataGridContent():ArrayCollection{
            return this.dataGridContent;
        }

        public function setDataGridContent(dataProvider:ArrayCollection):void{
            this.dataGridContent = dataProvider;
        }

        public function removeElementFromDataGrid(id:int):void{
            var tempDataGridContent:ArrayCollection = this.getDataGridContent();
            tempDataGridContent.removeItemAt(id);
            this.setDataGridContent(tempDataGridContent);
        }
        /**
        * Handles the graph title
        */
        private function titleHandler(event:Event):void{
            this.label = event.target.text;
        }

        /**
        * Handles the click on the addProbeButton
        */
        private function addProbeHandler(event:MouseEvent):void{
            this.dataGridContent.addItem({Id: "",
                                          IndicatorName: "", 
                                          Name: "", 
                                          Description: "",
                                          PatternFilter: "", 
                                          ServerSource: "", 
                                          //color:"0xFFFFFF", 
                                          Option: this.dataGridContent.length});
        }

        /**
        * Handles the click on the graphTypeComboBox
        */
        private function changeGraphButtonMenuClickHandler(event:Event):void
        {
            var chartType:String="";
            //Get the type of the graph
            chartType=event.currentTarget.value.toString();
            if (chartType == "Line Graph")
            {
                EoSLogger.info("lineChartConst");
                //this.chartSelected=lineChartConst;
            }
            if (chartType == "Area Graph")
            {
                EoSLogger.info("areaChartConst");
                //this.chartSelected=areaChartConst;
            }
            if (chartType == "Column Graph")
            {
                EoSLogger.info("columnChartConst");
                //this.chartSelected=columnChartConst;
            }
        }

    }
}